-- ##########################################################################
-- #
-- #  Licensed Materials - Property of IBM
-- #  5724-C04
-- #
-- #  (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- #
-- #  US Government Users Restricted Rights - Use, duplication or
-- #  disclosure restricted by GSA ADP Schedule Contract with
-- #  IBM Corp.
-- #
-- #   File Information: Common/src/tedw_app/amx/fixpack2/misc/Insert_Host_Attrs.db2, tmnt_etl, tmnt_5.1.1, 511ITM04C
-- #   Revision: 1.1
-- #   Date: 11/25/02 17:35:47
-- ############################################################################

-----------------------------------------------
-- AMX_EID attribute
-----------------------------------------------

declare global temporary table temp1_compattr_HOST_AMX_EID (
  comp_id         integer,
  last_value  	  varchar(254) 
) 
with replace on commit preserve rows not logged
;


insert into session.temp1_compattr_HOST_AMX_EID
select
 ca.comp_id as comp_id,
 ca.compattr_val last_value
from 
 twg.cur_compattr ca,
 twg.cur_comp c
where
 (c.comptyp_cd in ('IP_INTERFACE','TME_ENDPOINT') or
 c.comptyp_cd like '%_HOST%' ) and
 ca.attrtyp_cd='AMX_EID' and
 ca.comp_id=c.comp_id
group by
 ca.comp_id, ca.compattr_val
; 

--select * from session.temp1_compattr_HOST_AMX_EID;

declare global temporary table temp2_compattr_HOST_AMX_EID (
  Comp_id        integer,
  Last_Value     varchar(120)
) 
with replace on commit preserve rows not logged
;

insert into session.temp2_compattr_HOST_AMX_EID
select 
 c1.comp_id as Comp_id,
 ca1.last_value as Last_Value
from 
 session.temp2_comp_host c1 left outer join session.temp1_compattr_HOST_AMX_EID ca1
 on ( c1.comp_id = ca1.comp_id)
;

--select * from session.temp2_compattr_HOST_AMX_EID;



----------------------------------------------------------
-- Insert the attribute in TWG.CompAttr
-- 2 cases : 
-- 1) it is a new component and we insert the attribute 
--    for the first time
-- 2) it is not a new component, we need to be sure 
--    we are not receiving a late measurement for this component 
--    if it is a late measurement we should not insert the attribute
--    we already have the last version in the compattr
---------------------------------------------------------- 

insert into twg.compattr 
select  
 0 as compattr_id,
 c1.comp_id as comp_id,  
 'AMX_EID' as AttrTyp_Cd,  
 current timestamp - current timezone as CompAttr_Strt_DtTm, 
 '9999-01-01-00.00.00.000000' as CompAttr_End_DtTm, 
 char(d.eid) as CompAttr_Val 
from    
 AMX.stage_ep_no_ex d,
 session.temp2_comp_host c1,
 session.temp2_compattr_HOST_AMX_EID ca1
where   
  c1.comp_nm=d.host_nm and
  ca1.comp_id=c1.comp_id and
  ca1.last_value is null 
group by
  c1.comp_id, d.eid
;

--select * from twg.compattr;


insert into twg.compattr 
select  
 0 as compattr_id,
 c1.comp_id as comp_id,  
 'AMX_EID' as AttrTyp_Cd,  
 current timestamp - current timezone as CompAttr_Strt_DtTm, 
 '9999-01-01-00.00.00.000000' as CompAttr_End_DtTm, 
 char(d.eid) as CompAttr_Val 
from    
 AMX.stage_ep_no_ex d,
 session.temp2_comp_host c1,
 session.temp2_compattr_HOST_AMX_EID ca1
where   
  c1.comp_nm=d.host_nm and
  ca1.comp_id=c1.comp_id and
  ca1.last_value is not null and
  ca1.last_value != char(d.eid)
group by
  c1.comp_id,  d.eid
;

--select * from twg.compattr;

-----------------------------------------------
-- AMX_GMT_OFFSET attribute
-----------------------------------------------

declare global temporary table temp1_compattr_HOST_AMX_GMT_OFFSET (
  comp_id         integer,
  last_value  	  varchar(254) 
) 
with replace on commit preserve rows not logged
;


insert into session.temp1_compattr_HOST_AMX_GMT_OFFSET
select
 ca.comp_id as comp_id,
 ca.compattr_val last_value
from 
 twg.cur_compattr ca,
 twg.cur_comp c
where
 (c.comptyp_cd in ('IP_INTERFACE','TME_ENDPOINT') or
 c.comptyp_cd like '%_HOST%') and
 ca.attrtyp_cd='AMX_GMT_OFFSET' and
 ca.comp_id=c.comp_id
group by
 ca.comp_id, ca.compattr_val
; 

--select * from session.temp1_compattr_HOST_AMX_GMT_OFFSET;

declare global temporary table temp2_compattr_HOST_AMX_GMT_OFFSET (
  Comp_id        integer,
  Last_Value     varchar(120)
) 
with replace on commit preserve rows not logged
;

insert into session.temp2_compattr_HOST_AMX_GMT_OFFSET
select 
 c1.comp_id as Comp_id,
 ca1.last_value as Last_Value
from 
 session.temp2_comp_host c1 left outer join session.temp1_compattr_HOST_AMX_GMT_OFFSET ca1
 on ( c1.comp_id = ca1.comp_id)
;

--select * from session.temp2_compattr_HOST_AMX_GMT_OFFSET;



----------------------------------------------------------
-- Insert the attribute in TWG.CompAttr
-- 2 cases : 
-- 1) it is a new component and we insert the attribute 
--    for the first time
-- 2) it is not a new component, we need to be sure 
--    we are not receiving a late measurement for this component 
--    if it is a late measurement we should not insert the attribute
--    we already have the last version in the compattr
---------------------------------------------------------- 

insert into twg.compattr 
select  
 0 as compattr_id,
 c1.comp_id as comp_id,  
 'AMX_GMT_OFFSET' as AttrTyp_Cd,  
 current timestamp - current timezone as CompAttr_Strt_DtTm, 
 '9999-01-01-00.00.00.000000' as CompAttr_End_DtTm, 
 char(d.gmt_offset) as CompAttr_Val 
from    
 AMX.stage_ep_no_ex d,
 session.temp2_comp_host c1,
 session.temp2_compattr_HOST_AMX_GMT_OFFSET ca1
where   
  c1.comp_nm=d.host_nm and
  ca1.comp_id=c1.comp_id and
  ca1.last_value is null 
group by
  c1.comp_id, d.gmt_offset
;

--select * from twg.compattr;


insert into twg.compattr 
select  
 0 as compattr_id,
 c1.comp_id as comp_id,  
 'AMX_GMT_OFFSET' as AttrTyp_Cd,  
 current timestamp - current timezone as CompAttr_Strt_DtTm, 
 '9999-01-01-00.00.00.000000' as CompAttr_End_DtTm, 
 char(d.gmt_offset) as CompAttr_Val 
from    
 AMX.stage_ep_no_ex d,
 session.temp2_comp_host c1,
 session.temp2_compattr_HOST_AMX_GMT_OFFSET ca1
where   
  c1.comp_nm=d.host_nm and
  ca1.comp_id=c1.comp_id and
  ca1.last_value is not null and
  ca1.last_value != char(d.gmt_offset)
group by
  c1.comp_id,  d.gmt_offset
;

--select * from twg.compattr;

-----------------------------------------------
-- LAST_IP_ADDRESS attribute
-----------------------------------------------

declare global temporary table temp1_compattr_HOST_LAST_IP_ADDRESS (
  comp_id         integer,
  last_value  	  varchar(254) 
) 
with replace on commit preserve rows not logged
;


insert into session.temp1_compattr_HOST_LAST_IP_ADDRESS
select
 ca.comp_id as comp_id,
 ca.compattr_val last_value
from 
 twg.cur_compattr ca,
 twg.cur_comp c
where
 (c.comptyp_cd in ('IP_INTERFACE','TME_ENDPOINT') or
 c.comptyp_cd like '%_HOST%' ) and
 ca.attrtyp_cd='LAST_IP_ADDRESS' and
 ca.comp_id=c.comp_id
group by
 ca.comp_id, ca.compattr_val
; 

--select * from session.temp1_compattr_HOST_LAST_IP_ADDRESS;

declare global temporary table temp2_compattr_HOST_LAST_IP_ADDRESS (
  Comp_id        integer,
  Last_Value     varchar(120)
) 
with replace on commit preserve rows not logged
;

insert into session.temp2_compattr_HOST_LAST_IP_ADDRESS
select 
 c1.comp_id as Comp_id,
 ca1.last_value as Last_Value
from 
 session.temp2_comp_host c1 left outer join session.temp1_compattr_HOST_LAST_IP_ADDRESS ca1
 on ( c1.comp_id = ca1.comp_id)
;

--select * from session.temp2_compattr_HOST_LAST_IP_ADDRESS;



----------------------------------------------------------
-- Insert the attribute in TWG.CompAttr
-- 2 cases : 
-- 1) it is a new component and we insert the attribute 
--    for the first time
-- 2) it is not a new component, we need to be sure 
--    we are not receiving a late measurement for this component 
--    if it is a late measurement we should not insert the attribute
--    we already have the last version in the compattr
---------------------------------------------------------- 

insert into twg.compattr 
select  
 0 as compattr_id,
 c1.comp_id as comp_id,  
 'LAST_IP_ADDRESS' as AttrTyp_Cd,  
 current timestamp - current timezone as CompAttr_Strt_DtTm, 
 '9999-01-01-00.00.00.000000' as CompAttr_End_DtTm, 
 char(d.ip_addr) as CompAttr_Val 
from    
 AMX.stage_ep_no_ex d,
 session.temp2_comp_host c1,
 session.temp2_compattr_HOST_LAST_IP_ADDRESS ca1
where   
  c1.comp_nm=d.host_nm and
  ca1.comp_id=c1.comp_id and
  ca1.last_value is null 
group by
  c1.comp_id, d.ip_addr
;

--select * from twg.compattr;


insert into twg.compattr 
select  
 0 as compattr_id,
 c1.comp_id as comp_id,  
 'LAST_IP_ADDRESS' as AttrTyp_Cd,  
 current timestamp - current timezone as CompAttr_Strt_DtTm, 
 '9999-01-01-00.00.00.000000' as CompAttr_End_DtTm, 
 char(d.ip_addr) as CompAttr_Val 
from    
 AMX.stage_ep_no_ex d,
 session.temp2_comp_host c1,
 session.temp2_compattr_HOST_LAST_IP_ADDRESS ca1
where   
  c1.comp_nm=d.host_nm and
  ca1.comp_id=c1.comp_id and
  ca1.last_value is not null and
  ca1.last_value != char(d.ip_addr)
group by
  c1.comp_id,  d.ip_addr
;

--select * from twg.compattr;

----------------------------------------------------
-- Insert into the Endpoints staging table the ITM
-- hosts that have already be inserted into TWG.COMP
-----------------------------------------------------

-- AVA_HOST or IP_HOST
insert into AMX.Stage_ep_no_ex
select
 integer(ca1.compattr_val) as eid,
 c1.comp_nm as host_nm,
 ca3.compattr_val as ip_addr,
 '' as endpoint_label,
 decimal(ca2.compattr_val) as GMT_offset
from
 twg.cur_compattr ca1,
 twg.cur_compattr ca2,
 twg.cur_compattr ca3,
 twg.cur_comp c1
where
 ca1.attrtyp_cd='AMX_EID' and
 ca2.attrtyp_cd='AMX_GMT_OFFSET' and
 ca3.attrtyp_cd='LAST_IP_ADDRESS' and
 ca1.comp_id=ca2.comp_id and
 ca1.comp_id=ca3.comp_id and
 c1.comp_id=ca1.comp_id and
 c1.comptyp_cd like '%HOST%' and
 not exists (
 select 1 
 from 
  AMX.Stage_ep_no_ex e
 where
  e.eid=integer(ca1.compattr_val) and
  e.host_nm = c1.comp_nm and
  e.ip_addr = ca3.compattr_val and
  e.GMT_offset = decimal(ca2.compattr_val)
  	)
 group by
 c1.comp_nm,ca3.compattr_val,
 ca1.compattr_val, ca2.compattr_val
;

--select * from AMX.Stage_ep_no_ex;

-- IP_INTERFACE

insert into AMX.Stage_ep_no_ex
select
 integer(ca1.compattr_val) as eid,
 'UNKNOWN' as host_nm,
 c1.comp_nm as ip_addr,
 ''  as endpoint_label,
 decimal(ca2.compattr_val) as GMT_offset
from
 twg.cur_compattr ca1,
 twg.cur_compattr ca2,
 twg.cur_comp c1
where
 ca1.attrtyp_cd='AMX_EID' and
 ca2.attrtyp_cd='AMX_GMT_OFFSET' and
 ca1.comp_id=ca2.comp_id and
 c1.comp_id=ca1.comp_id and
 c1.comptyp_cd in ('IP_INTERFACE') and
 not exists (
 select 1 
 from 
  AMX.Stage_ep_no_ex e
 where
  e.eid=integer(ca1.compattr_val) and
  e.host_nm = 'UNKNOWN' and
  e.ip_addr = c1.comp_nm and
  e.GMT_offset = decimal(ca2.compattr_val)
  	)
 group by
 c1.comp_nm,
 ca1.compattr_val, ca2.compattr_val
;

--select * from AMX.Stage_ep_no_ex;

declare global temporary table temp3_comp_host (
  comp_id	integer,
  eid		varchar(10),
  comp_nm 	varchar(120),
  comptyp_cd	varchar(17)
) 
with replace on commit preserve rows not logged
;


insert into session.temp3_comp_host
select 
 c.comp_id as comp_id,
 '' as eid,
 c.comp_nm as comp_nm,
 c.comptyp_cd as comptyp_cd
from 
 session.temp2_comp_host c
where 
not exists ( select 1
  from  
    twg.cur_compattr ca
  where 
    ca.comp_id=c.comp_id and
    ca.attrtyp_cd='AMX_EID'
          )
group by 
 c.comp_nm, c.comp_id, comptyp_cd
union
select 
 c.comp_id as comp_id,
 ca.compattr_val as eid,
 c.comp_nm as comp_nm,
 c.comptyp_cd as comptyp_cd
 from 
 session.temp2_comp_host c,
 twg.cur_compattr ca
 where 
 ca.comp_id=c.comp_id and
 ca.attrtyp_cd='AMX_EID'
group by 
 c.comp_nm, c.comp_id, c.comptyp_cd, ca.compattr_val
;

--select * from session.temp3_comp_host;

---------------------------------------------
-- temporary table to find the component types
-- that have measurements in the source
---------------------------------------------
declare global temporary table Source_Inst_With_Msmt(
  comptyp_cd varchar(17),
  iid   bigint,
  rcid  bigint,
  eid   integer
)
with replace on commit preserve rows not logged
;

insert into session.Source_Inst_With_Msmt
select
t.comptyp_cd as comptyp_cd,
i.iid as iid,
i.rcid as rcid,
i.eid as eid
from
AMX.stage_instkey_no_ex i,
AMX.stage_msmt_no_ex m,
AMX.stage_resources r,
AMX.resource_transl t
where
i.iid=m.iid and
i.rcid=m.rcid and
i.eid=m.eid and
r.rcid=m.rcid and
r.eid=i.eid and
r.resource=t.resource
group by
t.comptyp_cd,i.iid,i.rcid,i.eid
;

--select * from session.Source_Inst_With_Msmt;

---------------------------------------------
-- temporary table to find the component types
-- that have attributes in the source
---------------------------------------------
declare global temporary table Source_Inst_With_Attr(
  comptyp_cd	varchar(17),
  iid   bigint,
  rcid  bigint,
  eid   integer
)
with replace on commit preserve rows not logged
;

insert into session.Source_Inst_With_Attr
select
t.comptyp_cd as comptyp_cd,
i.iid as iid,
i.rcid as rcid,
i.eid as eid
from
AMX.stage_instkey_no_ex i,
AMX.stage_attr_no_ex a,
AMX.stage_resources r,
AMX.resource_transl t
where
i.iid=a.iid and
i.rcid=a.rcid and
i.eid=a.eid and
r.rcid=a.rcid and
r.eid=i.eid and
r.resource=t.resource
group by
t.comptyp_cd,i.iid,i.rcid,i.eid
;

--select * from session.Source_Inst_With_Attr;
