-- ##########################################################################
-- #
-- #  Licensed Materials - Property of IBM
-- #  Product ID = 5724-C04
-- #
-- #  (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- #
-- #  US Government Users Restricted Rights - Use, duplication or
-- #  disclosure restricted by GSA ADP Schedule Contract with
-- #  IBM Corp.
-- #
-- ############################################################################

--#iftag fixpack_400

-------------------
-- DROP FACT TABLES
-------------------

--
-- CPU fact tables
--
DROP TABLE AMY.STAGE_F_CPU_HOUR;
DROP TABLE AMY.F_CPU_HOUR;
DROP TABLE AMY.F_CPU_DAY;
DROP TABLE AMY.F_CPU_WEEK;
DROP TABLE AMY.F_CPU_MONTH;
--
-- File fact tables
--
DROP TABLE AMY.STAGE_F_FILE_HOUR;
DROP TABLE AMY.F_FILE_HOUR;
DROP TABLE AMY.F_FILE_DAY;
DROP TABLE AMY.F_FILE_WEEK;
DROP TABLE AMY.F_FILE_MONTH;
--
-- File System fact tables
--
DROP TABLE AMY.STAGE_F_FS_HOUR;
DROP TABLE AMY.F_FS_HOUR;
DROP TABLE AMY.F_FS_DAY;
DROP TABLE AMY.F_FS_WEEK;
DROP TABLE AMY.F_FS_MONTH;
--
-- Logical Disk fact tables
--
DROP TABLE AMY.STAGE_F_LDISK_HOUR;
DROP TABLE AMY.F_LDISK_HOUR;
DROP TABLE AMY.F_LDISK_DAY;
DROP TABLE AMY.F_LDISK_WEEK;
DROP TABLE AMY.F_LDISK_MONTH;
--
-- Phisical Disk fact tables
--
DROP TABLE AMY.STAGE_F_PDISK_HOUR;
DROP TABLE AMY.F_PDISK_HOUR;
DROP TABLE AMY.F_PDISK_DAY;
DROP TABLE AMY.F_PDISK_WEEK;
DROP TABLE AMY.F_PDISK_MONTH;
--
-- Process fact tables
--
DROP TABLE AMY.STAGE_F_PROCESS_HOUR;
DROP TABLE AMY.F_PROCESS_HOUR;
DROP TABLE AMY.F_PROCESS_DAY;
DROP TABLE AMY.F_PROCESS_WEEK;
DROP TABLE AMY.F_PROCESS_MONTH;
--
-- Memory fact tables
--
DROP TABLE AMY.STAGE_F_MEMORY_HOUR;
DROP TABLE AMY.F_MEMORY_HOUR;
DROP TABLE AMY.F_MEMORY_DAY;
DROP TABLE AMY.F_MEMORY_WEEK;
DROP TABLE AMY.F_MEMORY_MONTH;
--
-- Network fact tables
--
DROP TABLE AMY.STAGE_F_NETWORK_HOUR;
DROP TABLE AMY.F_NETWORK_HOUR;
DROP TABLE AMY.F_NETWORK_DAY;
DROP TABLE AMY.F_NETWORK_WEEK;
DROP TABLE AMY.F_NETWORK_MONTH;
--
-- Printer fact tables
--
DROP TABLE AMY.STAGE_F_PRINTER_HOUR;
DROP TABLE AMY.F_PRINTER_HOUR;
DROP TABLE AMY.F_PRINTER_DAY;
DROP TABLE AMY.F_PRINTER_WEEK;
DROP TABLE AMY.F_PRINTER_MONTH;
--
-- Security fact tables
--
DROP TABLE AMY.STAGE_F_SECURITY_HOUR;
DROP TABLE AMY.F_SECURITY_HOUR;
DROP TABLE AMY.F_SECURITY_DAY;
DROP TABLE AMY.F_SECURITY_WEEK;
DROP TABLE AMY.F_SECURITY_MONTH;

-------------------------------
-- DROP METRIC DIMENSION TABLES
-------------------------------

--
-- CPU related metric dimension tables
--
DROP TABLE AMY.D_CPU_METRIC;
--
-- File and File System related metric dimension tables
--
DROP TABLE AMY.D_FS_METRIC;
--
-- Disk I/O related metric dimension tables
--
DROP TABLE AMY.D_IO_METRIC;
--
-- Memory related metric dimension tables
--
DROP TABLE AMY.D_MEM_METRIC;
--
-- Network related metric dimension tables
--
DROP TABLE AMY.D_NET_METRIC;
--
-- Printer related metric dimension tables
--
DROP TABLE AMY.D_PRN_METRIC;
--
-- Security related metric dimension tables
--
DROP TABLE AMY.D_SEC_METRIC;


----------------------------------
-- DROP COMPONENT DIMENSION TABLES
----------------------------------

--
-- Host with IP dimension tables
--
DROP TABLE AMY.D_HOST_IP;
--
-- CPU dimension tables
--
DROP TABLE AMY.D_CPU;
--
-- File dimension tables
--
DROP TABLE AMY.D_FILE;
--
-- File System dimension tables
--
DROP TABLE AMY.D_FS;
--
-- Logical Disk dimension tables
--
DROP TABLE AMY.D_LDISK;
--
-- Phisical Disk dimension tables
--
DROP TABLE AMY.D_PDISK;
--
-- Process dimension tables
--
DROP TABLE AMY.D_PROCESS;
--
-- Memory dimension tables
--
DROP TABLE AMY.D_MEMORY;
--
-- Network dimension tables
--
DROP TABLE AMY.D_NETWORK;
--
-- Printer dimension tables
--
DROP TABLE AMY.D_PRINTER;
--
-- Security dimension tables
--
DROP TABLE AMY.D_SECURITY;

--#endtag fixpack_400
