-- ##########################################################################
-- #
-- #  Licensed Materials - Property of IBM
-- #  Product ID = 5724-C04
-- #
-- #  (C) Copyright IBM Corp. 2002.  All Rights Reserved.
-- #
-- #  US Government Users Restricted Rights - Use, duplication or
-- #  disclosure restricted by GSA ADP Schedule Contract with
-- #  IBM Corp.
-- #
-- #  File Information: Common/src/tedw_app/amy/fixpack2/mart/dml/amy_mart_data.sql, tmnt_etl, tmnt_5.1.1_FP04
-- #  Revision: 1.1
-- #  Date: 11/13/02 10:08:08
-- ############################################################################

--#iftag fixpack_400

---------------------------------------------
---------------------------------------------
-- ////// Fixes for the AMY metadatas ///////
---------------------------------------------
---------------------------------------------

-- IY38862: fix the data format of the metric 'TotalAvail' collected by the DMXMemory RM

UPDATE AMY.D_ITM_METRIC
SET MET_UNITS = 'B'
WHERE MET_NAME = 'TotalAvail'
AND MSRC_NM = 'ITM for Operating Systems'
;

--
-- fix the name of the metric 'PagesFaultsSec' collected by the TMW_MemoryModel
--
UPDATE AMY.D_ITM_METRIC
SET MET_NAME = 'PagesFaultsSec'
WHERE MET_NAME = 'PageFaultsSec'
;

---------------------------------------------
---------------------------------------------
-- /////// Mart Pruning Control Data ////////
---------------------------------------------
---------------------------------------------

--
-- Insert data into the pruning control table...
--
DECLARE GLOBAL TEMPORARY TABLE PRUNE_MART_CONTROL (
  TABLE_NAME      VARCHAR(120) NOT NULL,
  PMARTC_DURATION DECIMAL(8,0) NOT NULL 
)
WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED
;

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_CPU_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_CPU_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_CPU_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_CPU_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_FILE_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_FILE_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_FILE_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_FILE_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_FS_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_FS_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_FS_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_FS_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_LDISK_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_LDISK_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_LDISK_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_LDISK_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PDISK_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PDISK_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PDISK_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PDISK_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PROCESS_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PROCESS_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PROCESS_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PROCESS_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_MEMORY_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_MEMORY_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_MEMORY_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_MEMORY_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_NETWORK_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_NETWORK_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_NETWORK_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_NETWORK_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PRINTER_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PRINTER_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PRINTER_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_PRINTER_MONTH', 00000300);

INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_SECURITY_HOUR',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_SECURITY_DAY',   00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_SECURITY_WEEK',  00000300);
INSERT INTO session.PRUNE_MART_CONTROL values ('AMY.F_SECURITY_MONTH', 00000300);

INSERT INTO AMY.PRUNE_MART_CONTROL
SELECT * FROM session.PRUNE_MART_CONTROL S
WHERE NOT EXISTS (
  SELECT 1 FROM
    AMY.PRUNE_MART_CONTROL T
  WHERE
    T.TABLE_NAME = S.TABLE_NAME 
);

--#endtag fixpack_400
